Index: trunk/src/VBox/Additions/common/crOpenGL/Linux_i386_glxapi_exports.py
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/Linux_i386_glxapi_exports.py	(revision 21127)
+++ trunk/src/VBox/Additions/common/crOpenGL/Linux_i386_glxapi_exports.py	(revision 21248)
@@ -22,5 +22,4 @@
 #"GetDriverConfig",
 "GetProcAddress",
-"FreeMemoryMESA",
 "QueryExtension",
 "IsDirect",
@@ -34,5 +33,4 @@
 "CreateNewContext",
 "SelectEventSGIX",
-"QueryContextInfoEXT",
 "GetCurrentDrawable",
 "ChooseFBConfig",
@@ -42,6 +40,4 @@
 "GetSelectedEventSGIX",
 "GetCurrentReadDrawable",
-"ImportContextEXT",
-"GetContextIDEXT",
 "GetCurrentDisplay",
 "QueryServerString",
@@ -49,5 +45,4 @@
 "SelectEvent",
 "GetVisualFromFBConfigSGIX",
-"MakeCurrentReadSGI",
 "GetFBConfigFromVisualSGIX",
 "QueryDrawable",
@@ -55,16 +50,12 @@
 "GetConfig",
 "CreateGLXPbufferSGIX",
-"AllocateMemoryMESA",
-"GetMemoryOffsetMESA",
 "CreatePbuffer",
 "ChooseFBConfigSGIX",
 "WaitX",
 "GetVisualFromFBConfig",
-"CreateGLXPixmapMESA",
 #"GetScreenDriver",
 "GetFBConfigAttrib",
 "GetCurrentContext",
 "GetClientString",
-"GetCurrentDisplayEXT",
 "DestroyPixmap",
 "MakeCurrent",
@@ -72,5 +63,4 @@
 "GetProcAddressARB",
 "GetSelectedEvent",
-"FreeContextEXT",
 "DestroyPbuffer",
 "DestroyWindow",
@@ -80,5 +70,15 @@
 "MakeContextCurrent",
 "QueryExtensionsString",
-"GetFBConfigAttribSGIX"
+"GetFBConfigAttribSGIX",
+"FreeMemoryMESA",
+"QueryContextInfoEXT",
+"ImportContextEXT",
+"GetContextIDEXT",
+"MakeCurrentReadSGI",
+"AllocateMemoryMESA",
+"GetMemoryOffsetMESA",
+"CreateGLXPixmapMESA",
+"GetCurrentDisplayEXT",
+"FreeContextEXT"
 ];
 
Index: trunk/src/VBox/Additions/common/crOpenGL/SunOS_i386_glxapi_exports.py
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/SunOS_i386_glxapi_exports.py	(revision 21127)
+++ trunk/src/VBox/Additions/common/crOpenGL/SunOS_i386_glxapi_exports.py	(revision 21248)
@@ -22,5 +22,4 @@
 #"GetDriverConfig",
 "GetProcAddress",
-"FreeMemoryMESA",
 "QueryExtension",
 "IsDirect",
@@ -34,5 +33,4 @@
 "CreateNewContext",
 "SelectEventSGIX",
-"QueryContextInfoEXT",
 "GetCurrentDrawable",
 "ChooseFBConfig",
@@ -42,6 +40,4 @@
 "GetSelectedEventSGIX",
 "GetCurrentReadDrawable",
-"ImportContextEXT",
-"GetContextIDEXT",
 "GetCurrentDisplay",
 "QueryServerString",
@@ -49,5 +45,4 @@
 "SelectEvent",
 "GetVisualFromFBConfigSGIX",
-"MakeCurrentReadSGI",
 "GetFBConfigFromVisualSGIX",
 "QueryDrawable",
@@ -55,16 +50,12 @@
 "GetConfig",
 "CreateGLXPbufferSGIX",
-"AllocateMemoryMESA",
-"GetMemoryOffsetMESA",
 "CreatePbuffer",
 "ChooseFBConfigSGIX",
 "WaitX",
 "GetVisualFromFBConfig",
-"CreateGLXPixmapMESA",
 #"GetScreenDriver",
 "GetFBConfigAttrib",
 "GetCurrentContext",
 "GetClientString",
-"GetCurrentDisplayEXT",
 "DestroyPixmap",
 "MakeCurrent",
@@ -72,5 +63,4 @@
 "GetProcAddressARB",
 "GetSelectedEvent",
-"FreeContextEXT",
 "DestroyPbuffer",
 "DestroyWindow",
@@ -80,5 +70,15 @@
 "MakeContextCurrent",
 "QueryExtensionsString",
-"GetFBConfigAttribSGIX"
+"GetFBConfigAttribSGIX",
+"FreeMemoryMESA",
+"QueryContextInfoEXT",
+"ImportContextEXT",
+"GetContextIDEXT",
+"MakeCurrentReadSGI",
+"AllocateMemoryMESA",
+"GetMemoryOffsetMESA",
+"CreateGLXPixmapMESA",
+"GetCurrentDisplayEXT",
+"FreeContextEXT"
 ];
 
Index: trunk/src/VBox/Additions/common/crOpenGL/fakedri_glxfuncsList.h
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/fakedri_glxfuncsList.h	(revision 21127)
+++ trunk/src/VBox/Additions/common/crOpenGL/fakedri_glxfuncsList.h	(revision 21248)
@@ -36,5 +36,4 @@
 /*GLXAPI_ENTRY(GetDriverConfig)*/
 GLXAPI_ENTRY(GetProcAddress)
-GLXAPI_ENTRY(FreeMemoryMESA)
 GLXAPI_ENTRY(QueryExtension)
 GLXAPI_ENTRY(IsDirect)
@@ -48,5 +47,4 @@
 GLXAPI_ENTRY(CreateNewContext)
 GLXAPI_ENTRY(SelectEventSGIX)
-GLXAPI_ENTRY(QueryContextInfoEXT)
 GLXAPI_ENTRY(GetCurrentDrawable)
 GLXAPI_ENTRY(ChooseFBConfig)
@@ -56,6 +54,4 @@
 GLXAPI_ENTRY(GetSelectedEventSGIX)
 GLXAPI_ENTRY(GetCurrentReadDrawable)
-GLXAPI_ENTRY(ImportContextEXT)
-GLXAPI_ENTRY(GetContextIDEXT)
 GLXAPI_ENTRY(GetCurrentDisplay)
 GLXAPI_ENTRY(QueryServerString)
@@ -63,5 +59,4 @@
 GLXAPI_ENTRY(SelectEvent)
 GLXAPI_ENTRY(GetVisualFromFBConfigSGIX)
-GLXAPI_ENTRY(MakeCurrentReadSGI)
 GLXAPI_ENTRY(GetFBConfigFromVisualSGIX)
 GLXAPI_ENTRY(QueryDrawable)
@@ -69,16 +64,12 @@
 GLXAPI_ENTRY(GetConfig)
 GLXAPI_ENTRY(CreateGLXPbufferSGIX)
-GLXAPI_ENTRY(AllocateMemoryMESA)
-GLXAPI_ENTRY(GetMemoryOffsetMESA)
 GLXAPI_ENTRY(CreatePbuffer)
 GLXAPI_ENTRY(ChooseFBConfigSGIX)
 GLXAPI_ENTRY(WaitX)
 GLXAPI_ENTRY(GetVisualFromFBConfig)
-GLXAPI_ENTRY(CreateGLXPixmapMESA)
 /*GLXAPI_ENTRY(GetScreenDriver)*/
 GLXAPI_ENTRY(GetFBConfigAttrib)
 GLXAPI_ENTRY(GetCurrentContext)
 GLXAPI_ENTRY(GetClientString)
-GLXAPI_ENTRY(GetCurrentDisplayEXT)
 GLXAPI_ENTRY(DestroyPixmap)
 GLXAPI_ENTRY(MakeCurrent)
@@ -86,5 +77,4 @@
 GLXAPI_ENTRY(GetProcAddressARB)
 GLXAPI_ENTRY(GetSelectedEvent)
-GLXAPI_ENTRY(FreeContextEXT)
 GLXAPI_ENTRY(DestroyPbuffer)
 GLXAPI_ENTRY(DestroyWindow)
@@ -95,3 +85,14 @@
 GLXAPI_ENTRY(QueryExtensionsString)
 GLXAPI_ENTRY(GetFBConfigAttribSGIX)
-
+#ifdef VBOXOGL_FAKEDRI
+GLXAPI_ENTRY(FreeMemoryMESA)
+GLXAPI_ENTRY(QueryContextInfoEXT)
+GLXAPI_ENTRY(ImportContextEXT)
+GLXAPI_ENTRY(GetContextIDEXT)
+GLXAPI_ENTRY(MakeCurrentReadSGI)
+GLXAPI_ENTRY(AllocateMemoryMESA)
+GLXAPI_ENTRY(GetMemoryOffsetMESA)
+GLXAPI_ENTRY(CreateGLXPixmapMESA)
+GLXAPI_ENTRY(GetCurrentDisplayEXT)
+GLXAPI_ENTRY(FreeContextEXT)
+#endif